#!/usr/bin/python
# -*- coding: utf-8 -*-
####
####
####

from sqlalchemy import *
from sqlalchemy.orm import *
from sqlalchemy.ext.declarative import *

Base = declarative_base()

class Card(Base):
    __tablename__ = 'card'

    id = Column(Integer, primary_key=True)
    glyphs = Column(String)
    gloss = Column(String)
    meaning = Column(String)

    def __init__(self, id, glyphs, gloss, meaning):
        self.id = nid
        self.glyphs = glyphs
        self.gloss = gloss
        self.meaning = meaning

    def __repr__(self):
        return "<Card('%s','%s')>" % (self.id, self.meaning)

class Example(Base):
    __tablename__ = 'example'

    card_id = Column(Integer, ForeignKey('card.id'), primary_key=True)
    text = Column(String)

    def __init__(self, card_id, text):
        self.card_id = card_id
        self.text = text

    def __repr__(self):
        return "<Example('%s','%s')>" % (self.card_id, self.text)

Card.examples = relationship(Example, primaryjoin=Card.id == Example.card_id)


##
if __name__ == "__main__":

    ## See: http://www.sqlalchemy.org/docs/dialects/sqlite.html#connect-strings
    conn = 'sqlite:////home/sjcarbon/local/src/bazaar/wrenshoe/data/kanji/kanji.sqlite3'
    engine = create_engine(conn, echo=True)

    metadata = MetaData()

    Session = sessionmaker()
    Session.configure(bind=engine)
    session = Session()

    for c in session.query(Card): 
        print "card:", c.id, c.glyphs
        lst = c.examples 
        if len(lst) > 0:
            for e in lst: 
                print "example:", e.card_id, e.text
