;;;;
;;;; wrenshoe.lisp
;;;;

(require :day-to-day)
(require :cl-who)
(require :parenscript)
(require :hunchentoot)
(defpackage :wrenshoe
  (:use :cl))
;;	:parenscript))

(in-package #:wrenshoe)

;;;
;;; Server control.
;;; For testing--deployment should be through PhoneGap.
;;; 

;; Our global test server.
(defvar *server* nil)
(defvar *location* ; current dir?
  (asdf:system-relative-pathname (asdf:find-system 'wrenshoe) "app/"))
;;(merge-pathnames (d2d:pwd) "app/")) ; current 

;; HT logs.
(setf HUNCHENTOOT::*MESSAGE-LOG-PATHNAME*
      (merge-pathnames (merge-pathnames *location* "log/comb.log")))
;; (setf HUNCHENTOOT::*ACCESS-LOG-PATHNAME* *location*)
(setf HUNCHENTOOT::*SHOW-LISP-ERRORS-P* t)

;; ;; Hunchentoot settings. NOTE: no longer in newest version
;; (setq hunchentoot:*catch-errors-p* nil)
;; (setq hunchentoot:*log-lisp-backtraces-p* t)

;; 
(defun start ()
  ;; TODO: still working on this...
  ;;   (setq hunchentoot:*dispatch-table*
  ;; 	(nconc
  ;; 	 ;; 	 (list 'dispatch-easy-handlers
  ;; 	 ;; 	       (create-static-file-dispatcher-and-handler
  ;; 	 ;; 		"/hunchentoot/test/favicon.ico"
  ;; 	 ;; 		(make-pathname :name "favicon" :type "ico" :version nil
  ;; 	 ;; 			       :defaults *this-file*))
  ;; 	 ;; 		(make-pathname :name nil :type nil :version nil
  ;; 	 ;; 			       :defaults *this-file*)
  ;; 	 ;; 		"text/plain"))
  ;; 	 (mapcar (lambda (args)
  ;; 		   (apply 'create-prefix-dispatcher args))
  ;; 		 '(("/godot.js" godot-js)))
  ;; 	 (list 'default-dispatcher)))
  
  ;; (hunchentoot:define-easy-handler (what-is-this-1 :uri "/godot.html") ()
  ;;   (setf (hunchentoot:content-type*) "text/html")
  ;;   (static-base))

  ;; ;;   (hunchentoot:define-easy-handler (what-is-this-2 :uri "/godot.js") (foo)
  ;; ;;     (setf (hunchentoot:content-type*) "application/javascript")
  ;; ;;     (godot-js foo))
  ;; (hunchentoot:define-easy-handler (what-is-this-2 :uri "/godot.js") ()
  ;;   (setf (hunchentoot:content-type*) "application/javascript")
  ;;   (godot-js))

  (setf *server* (make-instance 'hunchentoot:acceptor :port 4242))
  (hunchentoot:start *server*))

;;   (setq hunchentoot:*dispatch-table*
;; 	(nconc
;; 	 (mapcar (lambda (args)
;; 		   (apply #'hunchentoot:create-prefix-dispatcher args))
;; 		 '(("/static/" serve-static)
;; 		   ("/what-color" what-color?)
;; 		   ("/main" main)))
;; 	 (list #'hunchentoot:default-dispatcher)))
;;   (setf *server* (hunchentoot:start-server :port 4242)))

;; 
(defun stop ()
  (hunchentoot:stop *server*))

;;;
;;; Page setup.
;;;


(defun static-base ()
  (let ((ubase "http://localhost/amigo2/javascript/"))
    (cl-who:with-html-output-to-string (strm)
      (:html
       (:head
	;; CSS.
	;;(:style ".draggable{background:pink;width:100px;height:100px;border-style:solid;border-width:1px;border-color:red;position:absolute;top:200px;left:200px;}")
	;; JS includes.
	(:script :type "text/javascript"
		 :src (d2d:ccat ubase "com/jquery-1.5.1.min.js"))
	(:script :type "text/javascript"
		 :src (d2d:ccat ubase "com/jquery-ui-1.8.13.custom.min.js"))
	(:script :type "text/javascript"
		 :src (d2d:ccat ubase "com/raphael-min.js"))
	(:script :type "text/javascript"
		 :src "http://localhost:4242/godot.js"))

       (:body
	(:h2 "GODOT")
	(:div :id "zoo")	      
	(:div :id "godot")
	
	;;(:div :id "location" "current div location")
	;;(:div :id "snap" "snap to")
	;;(:div :id "new-term" (:a :href "#" "new term"))
	;;(:div :id "new-association" (:a :href "#" "new association"))
	;;(:div :id "new-gp" (:a :href "#" "new gene product"))
	
	)))))

;;
(setf parenscript:*js-string-delimiter* #\")
