#!/usr/bin/perl
####
#### The exceptions we use in Wrenshoe land.
####

package Wrenshoe::Error;

use strict;
use utf8;


## The special exceptions that we'll use.
use Exception::Class(
		     'WrenshoeError' =>
		     {
		      description => 'general error',
		      fields => ['message']
		     },

		     ## Errors when trying to read/get a input
		     ## resource.
		     'WrenshoeDataError' =>
		     {
		      isa => 'WrenshoeError',
		      description => 'error while getting/reading input',
		      fields => ['resource', 'type', 'message']
		     },

		     ## Errors when parsing/compiling a file.
		     'WrenshoeCompileError' =>
		     {
		      isa => 'WrenshoeError',
		      description => 'error during input compilation',
		      fields => ['line', 'type', 'message']
		     },
		    );



1;
