use strict;
use Test::More 'no_plan';
use Data::Dumper;
use Try::Tiny;

use Wrenshoe::Error;


try {
  die("whatever");
}catch{
  if( $_->isa('WrenshoeCompileError') ){
    fail('die not properly caught');
  }else{
    pass('die properly caught');
  }
};

try {
  WrenshoeCompileError->throw(line=>4, type=>'foo', message=>'bar');
}catch{
  if( $_->isa('WrenshoeCompileError') ){
    is($_->line, 4, 'got line 1');
    ok($_->type eq 'foo', 'got type 1');
    ok($_->message eq 'bar', 'got message 1');
  }else{
    fail('compile exception not properly caught');
  }
};

try {
  WrenshoeDataError->throw(resource=>'bib', type=>'foo', message=>'bar');
}catch{
  if( $_->isa('WrenshoeCompileError') ){
    fail('data exception not properly caught');
  }elsif( $_->isa('WrenshoeDataError') ){
    ok($_->resource eq 'bib', 'got resource 2');
    ok($_->type eq 'foo', 'got type 2');
    ok($_->message eq 'bar', 'got message 2');
  }else{
    fail('data exception not properly caught');
  }
};
