use strict;
use Test::More 'no_plan';
use Data::Dumper;
use Try::Tiny;

use Wrenshoe::Utilities qw(:all);
#use Wrenshoe::Compile;
#use Wrenshoe::Error;
use Wrenshoe::DeckSet;

## Universal setup.
my $c = Wrenshoe::Compile->new();
my $deck = undef; # will reuse this one a lot
my $triggered_p = 0; # will reuse this one a lot
my $test_name = '???';


## Technically a bad URL, but go for it.
my $t1_url ='https://docs.google.com/spreadsheet/ccc?key=0AoMWJeL67IDbdGNCdUlkQWo5ZlRKRk5CVTNzMm9CYXc&usp=sharing';
#my $t1_url ='https://docs.google.com/spreadsheet/pub?key=0AoMWJeL67IDbdGNCdUlkQWo5ZlRKRk5CVTNzMm9CYXc&output=txt&sheet=od7';
my $ds = Wrenshoe::DeckSet->new();
$ds->add_google_spreadsheet($t1_url);

is($ds->count(), 2, "got the two decks");
out("json\n" . $ds->json());

# ## Test 04.
# {
#   $test_name = '04';
#   $triggered_p = 0;

#   try{
#     $c->parse_filename('data/test04.wrenshoe');
#   }catch{
#     $triggered_p = 1;
#     #err('foo1: ' . $c->deck()->okay());
#     #err('foo2: ' . $_->message);
#     #err('foo3: ' . scalar(@{$c->deck()->get_cards()}));
#   }finally{
#     fail("unexpected error $test_name") if $triggered_p;
#   };

#   is(scalar(@{$c->deck()->get_columns()}), 4, "$test_name got 4 cols");
#   is(scalar(@{$c->deck()->get_cards()}), 3, "$test_name got 4 cards");
#   ok($c->deck()->name() eq 'uber title', "$test_name got title");
#   ok($c->deck()->description() eq 'desc', "$test_name got description");
#   my $cards = $c->deck()->get_cards();
#   ok($$cards[2]->{'title3'} eq 'fooC3', "$test_name card title check");
# }

# ## Test 05.
# {
#   $test_name = '05';
#   $triggered_p = 0;

#   try{
#     $c->parse_filename('data/test05.wrenshoe');
#   }catch{
#     $triggered_p = 1;
#     if( $_->isa('WrenshoeCompileError') ){
#       is($_->line, 9, "$test_name bad line 9");
#       is($_->type, 'tag', "$test_name bad tag");
#       is($_->message, 'missing tag entry (maybe empty)', "$test_name message");
#     }else{
#       fail("bad error $test_name");
#     }
#   }finally{
#     fail("skipped error $test_name") if ! $triggered_p;
#   };
# }
